(in-package #:%kirk-v2/scheduler/utils)

(define-condition negative-cycle (error)
  ())

(defun floyd-warshall! (d-matrix)
  ;;(check-type d-matrix (simple-array single-float))
  (declare (type (simple-array double-float 2) d-matrix))
  (let ((mag-v (array-dimension d-matrix 0)))
    (dotimes (k mag-v)
      (dotimes (i mag-v)
        (dotimes (j mag-v)
          (let ((dist-via-k (+ (aref d-matrix i k) (aref d-matrix k j)))
                (shortest-dist-so-far (aref d-matrix i j)))
            (when (and (= i j)
                       (minusp dist-via-k))
              (error 'negative-cycle))
            (when (> shortest-dist-so-far dist-via-k)
              (setf (aref d-matrix i j) dist-via-k)))))))
  d-matrix)
